ExternalValue (Bouncy Castle Library 1.85 API Specification)
Date: 2026-07-12

org.bouncycastle.asn1.bc

## Class ExternalValue

- java.lang.Object
- - org.bouncycastle.asn1.ASN1Object
  - - org.bouncycastle.asn1.bc.ExternalValue

- All Implemented Interfaces:
    ASN1Encodable, Encodable

      public class ExternalValue
      extends ASN1Object

  Based on External Keys And Signatures For Use In Internet PKI draft-ounsworth-pq-external-pubkeys-00

        ExternalValue ::= SEQUENCE {
            location GeneralNames,    # MUST refer to a DER encoded SubjectPublicKeyInfo/Signature  (may be Base64)
            hashAlg AlgorithmIdentifier,
            hashVal OCTET STRING }

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ExternalValue(GeneralName location, AlgorithmIdentifier hashAlg, byte[] hashVal)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `AlgorithmIdentifier` | `getHashAlg()`
    `ASN1BitString` | `getHashVal()` Deprecated. use getHash(), the internal encoding is now an OCTET STRING
    `byte[]` | `getHashValue()`
    `static ExternalValue` | `getInstance(java.lang.Object o)`
    `GeneralName` | `getLocation()`
    `GeneralName[]` | `getLocations()`
    `ASN1Primitive` | `toASN1Primitive()` Method providing a primitive representation of this object suitable for encoding.

    - ### Methods inherited from class org.bouncycastle.asn1.ASN1Object

      `encodeTo, encodeTo, equals, getEncoded, getEncoded, hasEncodedTagValue, hashCode`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ExternalValue

          public ExternalValue(GeneralName location,
                               AlgorithmIdentifier hashAlg,
                               byte[] hashVal)

  - ### Method Detail

    - #### getInstance

          public static ExternalValue getInstance(java.lang.Object o)

    - #### getLocation

          public GeneralName getLocation()

    - #### getLocations

          public GeneralName[] getLocations()

    - #### getHashAlg

          public AlgorithmIdentifier getHashAlg()

    - #### getHashValue

          public byte[] getHashValue()

    - #### getHashVal

          public ASN1BitString getHashVal()

      Deprecated. use getHash(), the internal encoding is now an OCTET STRING
      Get the hash value as a BIT STRING.
      Returns:
        the hash value as a BIT STRING

    - #### toASN1Primitive

          public ASN1Primitive toASN1Primitive()

      Description copied from class: `ASN1Object`
      Method providing a primitive representation of this object suitable for encoding.
      Specified by:
        `toASN1Primitive` in interface `ASN1Encodable`
      Specified by:
        `toASN1Primitive` in class `ASN1Object`
      Returns:
        a primitive representation of this object.